Validate Sim Run
Preview. Usable today, but this endpoint can change before it is stable, without a new Kite-Version. Changes are announced before they ship.
Everything a create checks, for free, without creating anything: the spec parses and resolves, the files it
names are all here (files_required lists any that are not), every Python file is one Kite ships
(code_not_allowed), and kite plan’s answer: each evaluator’s status, the episodes and the estimate.
A spec error keeps the SDK’s diagnosis: param is its field (polciy), details.kite_code its code
(SPEC.UNKNOWN_FIELD), details.remediation the fix and details.location the line (specs/demo.yaml:5).
curl --request POST \
--url https://api.kiteml.com/v1/sim_runs/validate \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"files": {
"../evals": {
"kind": "directory",
"shipped": "evals"
}
},
"spec_path": "specs/smoke.yaml",
"spec_yaml": "kite_spec_version: \"2\"\nname: smoke\npolicy: {kind: scripted_pick, ref: scripted_pick}\n..."
}
'import requests
url = "https://api.kiteml.com/v1/sim_runs/validate"
payload = {
"files": { "../evals": {
"kind": "directory",
"shipped": "evals"
} },
"spec_path": "specs/smoke.yaml",
"spec_yaml": "kite_spec_version: \"2\"
name: smoke
policy: {kind: scripted_pick, ref: scripted_pick}
..."
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
files: {'../evals': {kind: 'directory', shipped: 'evals'}},
spec_path: 'specs/smoke.yaml',
spec_yaml: 'kite_spec_version: "2"\nname: smoke\npolicy: {kind: scripted_pick, ref: scripted_pick}\n...'
})
};
fetch('https://api.kiteml.com/v1/sim_runs/validate', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.kiteml.com/v1/sim_runs/validate",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'files' => [
'../evals' => [
'kind' => 'directory',
'shipped' => 'evals'
]
],
'spec_path' => 'specs/smoke.yaml',
'spec_yaml' => 'kite_spec_version: "2"
name: smoke
policy: {kind: scripted_pick, ref: scripted_pick}
...'
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.kiteml.com/v1/sim_runs/validate"
payload := strings.NewReader("{\n \"files\": {\n \"../evals\": {\n \"kind\": \"directory\",\n \"shipped\": \"evals\"\n }\n },\n \"spec_path\": \"specs/smoke.yaml\",\n \"spec_yaml\": \"kite_spec_version: \\\"2\\\"\\nname: smoke\\npolicy: {kind: scripted_pick, ref: scripted_pick}\\n...\"\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.kiteml.com/v1/sim_runs/validate")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"files\": {\n \"../evals\": {\n \"kind\": \"directory\",\n \"shipped\": \"evals\"\n }\n },\n \"spec_path\": \"specs/smoke.yaml\",\n \"spec_yaml\": \"kite_spec_version: \\\"2\\\"\\nname: smoke\\npolicy: {kind: scripted_pick, ref: scripted_pick}\\n...\"\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.kiteml.com/v1/sim_runs/validate")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"files\": {\n \"../evals\": {\n \"kind\": \"directory\",\n \"shipped\": \"evals\"\n }\n },\n \"spec_path\": \"specs/smoke.yaml\",\n \"spec_yaml\": \"kite_spec_version: \\\"2\\\"\\nname: smoke\\npolicy: {kind: scripted_pick, ref: scripted_pick}\\n...\"\n}"
response = http.request(request)
puts response.read_body{
"ok": true,
"plan": {},
"price": {},
"object": "sim_run_validation",
"kite_version": "<string>"
}{
"error": {
"type": "<string>",
"code": "<string>",
"message": "<string>",
"param": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"type": "<string>",
"code": "<string>",
"message": "<string>",
"param": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"type": "<string>",
"code": "<string>",
"message": "<string>",
"param": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"type": "<string>",
"code": "<string>",
"message": "<string>",
"param": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"type": "<string>",
"code": "<string>",
"message": "<string>",
"param": "<string>",
"request_id": "<string>",
"details": {}
}
}Authorizations
A Kite API key (kite_...), from Platform API → Keys in the dashboard.
Headers
The dated contract your code was written against. Without it you get 2026-09-27; every response says which version served it.
2026-09-27 Body
The checks a create runs (kite plan), without creating anything or spending anything.
The spec file's text, as written
1 - 2000000Its path in your workspace: what errors cite
500Each path the spec names, as it names it
Show child attributes
Show child attributes
FIELD=VALUE, as kite --set
100The Kite release to run; default the latest
40Response
Successful Response
kite plan's answer: the resolved spec, each evaluator's status, the episodes and the estimate
What a run of it reserves: its tier, the tier's tokens per hour, the cap in minutes and the tokens reserved (0 while billing is off)
sim_run_validation "sim_run_validation"curl --request POST \
--url https://api.kiteml.com/v1/sim_runs/validate \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"files": {
"../evals": {
"kind": "directory",
"shipped": "evals"
}
},
"spec_path": "specs/smoke.yaml",
"spec_yaml": "kite_spec_version: \"2\"\nname: smoke\npolicy: {kind: scripted_pick, ref: scripted_pick}\n..."
}
'import requests
url = "https://api.kiteml.com/v1/sim_runs/validate"
payload = {
"files": { "../evals": {
"kind": "directory",
"shipped": "evals"
} },
"spec_path": "specs/smoke.yaml",
"spec_yaml": "kite_spec_version: \"2\"
name: smoke
policy: {kind: scripted_pick, ref: scripted_pick}
..."
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
files: {'../evals': {kind: 'directory', shipped: 'evals'}},
spec_path: 'specs/smoke.yaml',
spec_yaml: 'kite_spec_version: "2"\nname: smoke\npolicy: {kind: scripted_pick, ref: scripted_pick}\n...'
})
};
fetch('https://api.kiteml.com/v1/sim_runs/validate', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.kiteml.com/v1/sim_runs/validate",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'files' => [
'../evals' => [
'kind' => 'directory',
'shipped' => 'evals'
]
],
'spec_path' => 'specs/smoke.yaml',
'spec_yaml' => 'kite_spec_version: "2"
name: smoke
policy: {kind: scripted_pick, ref: scripted_pick}
...'
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.kiteml.com/v1/sim_runs/validate"
payload := strings.NewReader("{\n \"files\": {\n \"../evals\": {\n \"kind\": \"directory\",\n \"shipped\": \"evals\"\n }\n },\n \"spec_path\": \"specs/smoke.yaml\",\n \"spec_yaml\": \"kite_spec_version: \\\"2\\\"\\nname: smoke\\npolicy: {kind: scripted_pick, ref: scripted_pick}\\n...\"\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.kiteml.com/v1/sim_runs/validate")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"files\": {\n \"../evals\": {\n \"kind\": \"directory\",\n \"shipped\": \"evals\"\n }\n },\n \"spec_path\": \"specs/smoke.yaml\",\n \"spec_yaml\": \"kite_spec_version: \\\"2\\\"\\nname: smoke\\npolicy: {kind: scripted_pick, ref: scripted_pick}\\n...\"\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.kiteml.com/v1/sim_runs/validate")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"files\": {\n \"../evals\": {\n \"kind\": \"directory\",\n \"shipped\": \"evals\"\n }\n },\n \"spec_path\": \"specs/smoke.yaml\",\n \"spec_yaml\": \"kite_spec_version: \\\"2\\\"\\nname: smoke\\npolicy: {kind: scripted_pick, ref: scripted_pick}\\n...\"\n}"
response = http.request(request)
puts response.read_body{
"ok": true,
"plan": {},
"price": {},
"object": "sim_run_validation",
"kite_version": "<string>"
}{
"error": {
"type": "<string>",
"code": "<string>",
"message": "<string>",
"param": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"type": "<string>",
"code": "<string>",
"message": "<string>",
"param": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"type": "<string>",
"code": "<string>",
"message": "<string>",
"param": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"type": "<string>",
"code": "<string>",
"message": "<string>",
"param": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"type": "<string>",
"code": "<string>",
"message": "<string>",
"param": "<string>",
"request_id": "<string>",
"details": {}
}
}